import React, { Component, type ComponentType } from 'react';
import StyleSheet from '../StyleSheet/StyleSheet';
import View from '../View/View';
import Portal from '../Portal/Portal';


class AppContainer extends Component {
    render() {
        const { WrapperComponent } = this.props;
        let RootComponent = this.props.rootComponent;
        let innerView = (
            <RootComponent
                {...this.props.initialProps}
                rootTag={this.props.rootTag}>
                <Portal />
            </RootComponent>
        );

        if (WrapperComponent) {
            innerView = <WrapperComponent className='hello'>{innerView}</WrapperComponent>;
        }

        let appView =
            <View
                ref="main"
                id="hello"
                className={StyleSheet.rootClassName}
                style={styles.appContainer}>
                {innerView}
            </View>;

        return appView;
    }
}
var styles = StyleSheet.create({
    appContainer: {
        width: '100%',
        height: '100%',
    },
});

export default AppContainer;