/**
 * Copyright (c) 2015-present, JD.COM.
 * All rights reserved.
 */
'use strict';
import StyleSheet from '../StyleSheet/StyleSheet'

// get element x, y
function getCumulativeOffset(element) {
  var left, top;
  left = top = 0;
  if (element.offsetParent) {
    do {
      left += element.offsetLeft;
      top += element.offsetTop;
    } while ((element = element.offsetParent) && element.className && element.className.indexOf(StyleSheet.viewClassName) >= 0);
  }
  return {
    x : left,
    y : top
  };
}

// this functions returns the x, y, width and height of a given dom node
function getLayout(element) {
  var rect = getCumulativeOffset(element);
  return {
    x: rect.x,
    y: rect.y,
    width: element.offsetWidth,
    height: element.offsetHeight
  };
}

module.exports = getLayout;
